// MJInsertAlgorithm.h: interface for the CMJInsertAlgorithm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MJINSERTALGORITHM_H__4EFECB4D_9326_46EE_8789_97F42EA21284__INCLUDED_)
#define AFX_MJINSERTALGORITHM_H__4EFECB4D_9326_46EE_8789_97F42EA21284__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Algorithm.h"

class CMJInsertAlgorithm : public CAlgorithm  
{
public:
	void SolveMJ(float lambda, float mu);
	CMJInsertAlgorithm();
	CMJInsertAlgorithm(CVRPDoc* doc);
	virtual ~CMJInsertAlgorithm();

private:
	void InsertNodeToRoute(int NodeId,int RouteId);
	int ChooseNodeToInsert();
	float m_fMu;
	float m_fLambda;
	void CountInsertCost(int id);
	int SetNewRoute();
	void InitVariables();
};

#endif // !defined(AFX_MJINSERTALGORITHM_H__4EFECB4D_9326_46EE_8789_97F42EA21284__INCLUDED_)
